#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "functions.h"

//elemento idejimas i sarasa
void idejimas (struct el* *pradzia, struct el* *pabaiga, char *naujas)
 {
struct el *elem;

if (*pradzia == NULL)
	{
		elem = (struct el*) malloc(sizeof(struct el));
		elem -> duom = naujas;
		*pradzia = elem;
		*pabaiga = elem;
		(*pabaiga) -> kitas = NULL;
		(*pradzia) -> atgal = NULL;
	}
else {
		elem = (struct el*) malloc(sizeof(struct el));
		elem -> duom = naujas;
		(*pabaiga) -> kitas = elem;
		elem -> atgal = *pabaiga;
		*pabaiga = elem;
		(*pabaiga) -> kitas = NULL;
}
}

//saraso rasymas i faila
void spausdfile(struct el* *pradzia, FILE* f){
struct el *elem;

fprintf(f, "Surusiuotas dvipusis sarasas pagal abecele:\n\n");

elem = *pradzia;

while (elem != NULL) {
	fprintf(f, "\t%s\n", elem -> duom);
	elem = elem ->kitas;
}
}

//saraso istrinimas
void istrynimas(struct el* *pradzia){
struct el *elem;

elem = *pradzia;

	while (elem != NULL) {
		*pradzia = elem -> kitas;
		free(elem);
		elem = *pradzia;
	}
}

//rusiuoja pagal ABC
void rusiavimas(struct el* *pradzia){
struct el *elem; 
char *temp;
                   
elem = *pradzia;
                                     
while (elem->kitas!=NULL)
       { 
         
         if (palyginimas(elem->duom,elem->kitas->duom) == 1){

            temp=elem->duom;
            elem->duom=elem->kitas->duom;
            elem->kitas->duom=temp;
            elem=*pradzia;}
               
         
         else {elem=elem->kitas;}
                       
       }
     
}

//palygina ar abu irasai eina pagal ABC, jei taip grazina 0, jei ne, tada 1
int palyginimas(char *pir,char *antr) {
int a,b,c,i;
	a=strlen(pir);
	b=strlen(antr);

	if (a>=b) { 
		c=a;
	}
		else {
			c=b;
		}

	for (i=0;i<c;i++) {
		if (pir[i]<antr[i]) {
			return 0;
		}
		else if (pir[i]>antr[i]) {
			return 1;
		}	
	}
	return 0;
}

//saraso atspausdinimas
void spausd(struct el* *pradzia) {
struct el *elem;

elem = *pradzia;

while (elem != NULL) {
	printf("\t%s\n", elem -> duom);
	elem = elem ->kitas;
}
}